########################################
# -*- coding:Utf-8 -*- 
########################################

import es, psyco, playerlib
psyco.full()

name_map = es.ServerVar("eventscripts_currentmap")
round_max_with_awp = es.ServerVar("round_max_avec_awp")
round_max_without_awp = es.ServerVar("round_max_sans_awp")
user_min = es.ServerVar("player_min_active")
maps_ext = es.ServerVar("extension_map_on")

info = es.AddonInfo()
info.name = "Limite AWP Python"
info.author = "Cbirou et Belzébuth en invention. DoCky, Patneze et Sylv@in en Python. Testé par InSiD<- des InTenSiV'(phoenix)"
info.description = "Permet de limiter l'utilisation de l'AWP en fonction d'un nombre de round ou de joueurs. Script traduit en python et modifier"

# Création variable version
version_addons_limite_awp = es.ServerVar("addons_Python_Limite_AWP", "1.5")
# attribution de la valeur (au cas où celle si existe deja)
version_addons_limite_awp.set("1.5")
# la rendre plublic
version_addons_limite_awp.makepublic()
 

def config(M):
    global script
    script = {"activate" : 0, "deja awp" : [], "avec awp" : {}, "sans awp" : {}}
    es.server.cmd("es_xmexec ../addons/eventscripts/limite_awp/limite_awp.cfg")

    if M.split("_")[0] in str(maps_ext):
        script["activate"] = 1

    else:
        script["activate"] = 0

def load():
    config(str(name_map))

def es_map_start(ev):
    config(ev["mapname"])

def player_activate(ev):
    script["avec awp"][ev["userid"]] = 0
    script["sans awp"][ev["userid"]] = 0

def item_pickup(ev):
    if script["activate"]:
        # Si l'arme ramassée est un AWP
        if ev["item"] == "awp":
            
            # Si il n'y a pas assez de joueur
            if es.getplayercount() < int(user_min):
                remove_awp(ev["userid"])
                es.msg ("#multi", "#green[LIMITATION AWP]==>#lightgreen Il faut #default"+str(user_min)+"#lightgreen joueurs pour prendre #defaultl'AWP !!!")
                
            # Sinon (il y a assez de joueurs)
            else:
                
                # Si le joueur est dans la base
                if ev["userid"] in script["deja awp"]:
                    
                    # Si le joueur a atteind son quota de round AVEC AWP, on lui enlève                
                    if script["avec awp"][ev["userid"]] == int(round_max_with_awp):
                        remove_awp(ev["userid"])
                        es.msg ("#multi", "#green[LIMITATION AWP]==> #default"+str(ev["es_username"])+"#lightgreen doit lacher son AWP !!!")
                # Si le joueur n'est pas dans la base
                else:
                    script["deja awp"].append(ev["userid"])
                    script["avec awp"][ev["userid"]] += 1

def player_spawn(ev):

    if script["activate"]:

        if not es.getplayerprop(ev["userid"], "CBasePlayer.pl.deadflag"):
            
                # Arme n'est pas l'AWP
                if playerlib.getPlayer(ev["userid"]).get("primary") != "awp":
                    
                    #Si le joueur est présent dans la base
                    if ev["userid"] in script["deja awp"]:

                        # Si Le joueur n'a pas fait assez de round sans AWP on rajoute un round sans AWP
                        if script["sans awp"][ev["userid"]] < int(round_max_without_awp):
                            script["sans awp"][ev["userid"]] += 1

                        # Si le joueur a fait assez de round sans AWP on l'enlève de la base
                        if script["sans awp"][ev["userid"]] == int(round_max_without_awp):
                            script["deja awp"].remove(ev["userid"])

                # Arme est l'AWP
                else:
                    
                    # Il n'y a pas assez de joueurs, on lui enlève l'AWP
                    if es.getplayercount() < int(user_min):
                        remove_awp(ev["userid"])
                        es.msg ("#multi", "#green[LIMITATION AWP]==>#lightgreen Il faut #default"+str(user_min)+"#lightgreen joueurs pour prendre #defaultl'AWP !!!")
                    
                    # Il y a assez de joueur
                    else:
                        
                        # Si Le joueur est déjà dans la base
                        if ev["userid"] in script["deja awp"]:
                            
                            # Si Le joueur n'a pas atteind son quota de round AVEC AWP
                            if script["avec awp"][ev["userid"]] < int(round_max_with_awp):
                                script["deja awp"].append(ev["userid"])
                                script["avec awp"][ev["userid"]] += 1

                            # Si Le joueur n'a pas atteind son quota de round AVEC AWP
                            else:
                                
                                # Si Le joueur n'a pas fait assez de round sans AWP
                                if script["sans awp"][ev["userid"]] < int(round_max_without_awp):
                                    script["sans awp"][ev["userid"]] += 1
                                    remove_awp(ev["userid"])
                                    es.msg ("#multi", "#green[LIMITATION AWP]==> #default"+str(ev["es_username"])+"#lightgreen doit lacher son AWP !!!")

                        # Le Joueur n'est pas dans la base      
                        else:
                            script["deja awp"].append(ev["userid"])
                            script["avec awp"][ev["userid"]] += 1

def round_end(ev):

    #Pour tous les joueurs dans la base
    for userid in script["avec awp"]:

        # Si le joueur a fait son quota de round avec et sans AWP alors on le remet à zéro
        if script["avec awp"][userid] == int(round_max_with_awp) and script["sans awp"][userid] >= int(round_max_without_awp):
            script["avec awp"][userid] = 0
            script["sans awp"][userid] = 0

def remove_awp(userid):
    
    # On récupère les infos du joueur
    player = playerlib.getPlayer(userid)
    
    # On drop son AWP
    es.server.queuecmd("es_xremove %s" % player.get("weaponindex", "awp"))
    es.sexec(userid, "use weapon_knife")
    
    # on modifie son argent
    cash_player = player.get("cash") + 4750
	    
    # On vérifie que la totalité ne dépasse pas 16000$
    if cash_player <= 16000:
        player.set("cash", cash_player)
    else:
        player.set("cash", 16000)
    
